/*	LogD-Time-Manager 2d
	WRITTEN BY: [WING] Sir Drink a lot
	visit www.adminmod.de
	
	BESCHREIBUNG: 	Berechnet die vergangene Zeit auf der Map.
			In einer command.ini werden die Befehle und Zeitpunkte
			festgelegt, welche dann entsprechend der Mapzeit (in Sekunden)
			ausgefhrt werden sollen.
			
			In der command.ini immer mit dem hchsten Zeitwert beginnen!
			Seht euch die Beispiel command.ini an! Das Beispiel stellt
			ein 'Timeremaining' dar, wieviel Zeit noch auf der Map verbleiben.
			
			In dieser neuen Version werden jetzt alle Tasks in einer *.ini Datei abgelegt.
			Man kann jetzt auch mehrere Tasks anlegen, die zur gleichen Zeit ablaufen sollen.
			
			
	BEFEHLE:
	admin_tm_add 'Mapzeit in sec' 'Befehl'	:fgt einen Task zur (eingelesenen) Taskliste hinzu.
	admin_tm_del 'Task-ID'			:lscht einen Task aus der (eingelesenen) Taskliste.
	admin_tm_exec 'Task-ID'			:Fhrt einen Task aus, obwohl er nicht an der Reihe ist.
	admin_tm_kill				:Stoppt alle Taskausfhrungen und setzt alles zurck. Auch die vault.ini Eintrge.
	admin_tm_list 'ab Task-ID'		:Zeigt einem alle anstehenden Tasks (ab eingegebener TaskID+10)und fhrt eine Zeitkontrolle durch.
	admin_tm_load 'filename'		:Stoppt die Ausfhrung aller Tasks und liest eine neue Taskliste ein.
	admin_tm_write 'filename'		:schreibt die (bearbeitete) Taskliste in die angebene Datei.
	say timeleft				:Spricht die Zeit aus.
	
	
	
	!!!!HINWEIS/Important Notice!!!!
	
	Ich bernehme keine Verantwortung dafr, was ihr in eure command.ini schreibt
	und was dann passiert, wenn dieser Befehl ausgefhrt wird.
	Wenn Ihr z.B. irgendwelche rcon Befehle benutzt oder einfach nur 'quit'.
	Am Besten lasst ihr nur Adminmod Plugins ausfhren.
	
	You can not hold me responsible for your mistakes.  For example, if you set 
	rcon_password or quit in your command.ini then it is YOUR problem.  The
   	defaults should be quite secure....
   	
	---Changelog---
	20.03.03:	- Die Zeitberprfung beginnt erst, wenn ein Game_Commencing stattgefunden hat.
			- HandleSay, um das Timeleft im Chat abzufragen mit Sprachausgabe.
	
	26.02.03:	- auf das kill_timer wird ganz verzichtet!
	
	14.02.03:	- admin_tm_kill killt timer nicht mehr. Lscht aber sonst alles, dass nichts mehr ausgefhrt wird.
			- In tm_warn ein plugin_exec admin_tm_kill eingebaut, wenn sich die neue Wartezeit nicht ermitteln lsst.
			- in 'timer ' steht nur noch der TimerIndex der von tm_warn aufgerufen wird.
			- admin_tm_list wird die maximale Anzeige jeweils auf 10 Eintrge begrenzt.
			
	09.02.03:	- nderung der Rechte. Zur Bearbeitung der Taskliste braucht man RCON Recht. Soll vor Missbrauch schtzen.
	
	08.02.03:	- Komplette berarbeitung des Time-Managers.
			- Wegfall der mapzeitungebundenen Tasks.
			- Man kann jetzt mehrere Tasks zu einer bestimmten Mapzeit ausfhren lassen.
			- Es luft nur noch ein Timer.
			- Erweiterte Bearbeitungs-Ausgaben des Managers, dadurch bessere Kontrolle.
			- Zustzliche Ausgabe-Parameter an die vault.ini, die man mit anderen Plugins nutzen kann.
			  (Teamscore, Bester Spieler mit meisten Frags, Rundenanzahl und die die Mapzeit)
	
	geplante Erweiterungen:
	
			
	Befehlsstruktur:
	- Die Variable 'time' enthlt die Mapzeit. Sie wird bei Game_Commencing, Restart_Round, Round_Start, admin_tm_config,
	  admin_tm_list und tm_warn jeweils angepasst und berprft.
	- Die Vernderungen des mp_timelimits werden in Round_Start, tm_warn, admin_tm_list, tm_exec_task berprft und die
	  Variablen 'checktime' wird angepasst und das 'origtimelimit' in der Funktion 'time_change'
*/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE 131072

new STRING_VERSION[MAX_DATA_LENGTH] = "20.03.03";
new TextFileDir[MAX_TEXT_LENGTH]="addons/adminmod/config/tm/";

/*Definiert, wieviele Zeilen der command.ini ausgewertet werden*/
#define MAX_LINE 100

/*Check-Variablen fr tm_welt*/
new GameCommencing;
new checktime;
new origtimelimit;

/*Debug-Mode*/

new debug=0;

/* ---- Task-Abarbeitung ---- */
/*Die verbleibende Mapzeit*/
new time;

/*tm_pointer dient als Zeiger, wo wir uns gerade in der Abarbeitung befinden*/
new tm_pointer;

/*tm_line enthlt die maximale Anzahl der geladenen tasks*/
new tm_line;

/*Time enthlt die Zeitangaben der eingelesenen Tasks*/
new Time[MAX_LINE][MAX_NUMBER_LENGTH];

/*Execute enthlt die Befehle der eingelesenen Tasks*/
new Execute[MAX_LINE][MAX_DATA_LENGTH];

/*timer enthlt den TimerIndex. Der Timer ruft sch immer wieder entsprechend nach errechneter Wartezeit zwischen 'time' und 'Time' selber auf.
new timer;*/

/*Am 05.02.03 hinzugefgt. Vault.ini Variablen*/
new iRound;
new ScoreT[MAX_NUMBER_LENGTH];
new ScoreCT[MAX_NUMBER_LENGTH];

/* Fr die Zeit-Ansage*/
new iLastSpeak;

public admin_tm_add(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	
	new sNewTime[MAX_NUMBER_LENGTH];
	new sCommand[MAX_DATA_LENGTH];
	
	new i;
	new j;
	new iOldTime;
	new iNewTime;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(tm_line<99){
		strbreak(Data,sNewTime,sCommand,MAX_DATA_LENGTH);
		iNewTime=strtonum(sNewTime);
		if(strlen(sNewTime)!=0 && strlen(sCommand)!=0){
			for(i=0;i<tm_line;i++){
				iOldTime=strtonum(Time[i]);
				if(iNewTime>=iOldTime){
					for(j=tm_line;j>=i;j--){
						strcpy(Time[j+1],Time[j],MAX_NUMBER_LENGTH);
						strcpy(Execute[j+1],Execute[j],MAX_DATA_LENGTH);
					}
					break;
				}
			}
			strcpy(Time[i],sNewTime,MAX_NUMBER_LENGTH);
			strcpy(Execute[i],sCommand,MAX_DATA_LENGTH);
			tm_line++;
			snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Task hinzugefuegt!");
	        	selfmessage(Text);
	        	checktime = systemtime()-(systemtime()- checktime);
	        	time_change();
		}else{
			snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Konnte Task nicht hinzufuegen! Angaben fehlen! 'Mapzeit' oder 'Command'");
		        selfmessage(Text);
		}
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Kann keine Tasks mehr anfgen. Maximal %i zugelassen!",MAX_LINE-1);
		selfmessage(Text);
	}
        return PLUGIN_HANDLED;
}

public admin_tm_debug(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new iData;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	iData=strtonum(Data);
	
	if(iData>=1){
		iData=1;
	}else{
		iData=0;
	}	
	set_vaultnumdata("TM_DEBUG",iData);
	debug=iData;
	snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Debug-Modus auf %i gesetzt!",iData);
	selfmessage(Text);
	
	return PLUGIN_HANDLED;
}
	
	

public admin_tm_del(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	
	new i;
	new j;
	new iData;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	iData=strtonum(Data);
	
	if(iData<=tm_line){
		for(i=0;i<=tm_line;i++){
			if(iData==i){
				for(j=i;j<tm_line;j++){
					strcpy(Time[j],Time[j+1],MAX_NUMBER_LENGTH);
					strcpy(Execute[j],Execute[j+1],MAX_DATA_LENGTH);
				}
				break;
			}
		}
		tm_line--;
		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Task-ID %i (%i) wurde geloescht",i,iData);
		selfmessage(Text);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Kann Task-ID nicht finden!");
		selfmessage(Text);
	}
	return PLUGIN_HANDLED;
}

public admin_tm_exec(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iData;
		
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	iData=strtonum(Data);
	
	if(strlen(Execute[iData])==0){
		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Konnte Task-ID %i nicht ausfuehren!", iData);
        	selfmessage(Text);
        }else{
        	execute(Execute[iData]);
        }
        return PLUGIN_HANDLED;
}

public admin_tm_kill(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new dummy[MAX_NAME_LENGTH];
	new i;
	
	for(i=0;i<=tm_line;i++){
		Time[i][0]	=0;
		Execute[i][0]	=0;
	}
	tm_line			=0;
      	time 			=0;
	tm_pointer		=0;
      	iRound			=0;
	ScoreCT[0]		=0;
	ScoreT[0]		=0;
	
	set_vaultini(0,dummy);
	
	/*Damit wir aber neu starten knnen, halten wir mal die checktime und das origtimelimit aktuell*/
	checktime = systemtime()-(systemtime()- checktime);
	origtimelimit= getvar("mp_timelimit")*60+2;
	
	snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Alles zurueck gesetzt. Plugin beendet! Kann neu gestartet werden!");
        selfmessage(Text);
        
        return PLUGIN_HANDLED;
}

public admin_tm_list(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];
	new File[MAX_TEXT_LENGTH];
        new a;
        new i;
        new iData;
        
        convert_string(HLUserName,User,MAX_NAME_LENGTH);
        convert_string(HLData,Data,MAX_DATA_LENGTH);
        
        tm_best_player(0);
        
        a=time-strtonum(Time[tm_pointer]);
      	iData=strtonum(Data);
      	get_vaultdata("TM_FILE",File,MAX_TEXT_LENGTH);
      	if(iData>tm_line){
      		iData=0;
      	}      	
      	selfmessage("");
      	snprintf(Text,MAX_TEXT_LENGTH,"--- TASKLISTE: %s ---",File);
	selfmessage(Text);
      	selfmessage("TASK-ID -- ZEIT -- BEFEHL");
      	for(i=iData;i<iData+10;i++){
      		strinit(Text);
      		snprintf(Text,MAX_TEXT_LENGTH,"%i. --- %s --- %s",i,Time[i],Execute[i]);
      		strcpy(Text,Text,98);
      		selfmessage(Text);
      		if(time > strtonum(Time[i+1]) && time < strtonum(Time[i])){
      			selfmessage("===>Hier stehen wir<===");
      		}
      		if(i==tm_line){
      			selfmessage("--ENDE--");
      			i+=1;
      			break;
      		}
      	}
      	selfmessage("------------------------------------");
      	snprintf(Text,MAX_TEXT_LENGTH,"---^t^tTask %i bis %i   ^t^t  ---",iData,i-1);
	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"---^t^tvon insg. %i Tasks^t  ---",tm_line);
	selfmessage(Text);
      	selfmessage("------------------------------------");
      	snprintf(Text,MAX_TEXT_LENGTH,"Verbleibende Zeit: %i sec",time);
      	selfmessage(Text);
      	snprintf(Text,MAX_TEXT_LENGTH,"Naechster Befehl in %d Sekunden:",a);
      	selfmessage(Text);
	snprintf(Text,MAX_TEXT_LENGTH,"%s --- %s ",Time[tm_pointer],Execute[tm_pointer]);
      	strcpy(Text,Text,98);
      	selfmessage(Text);
      	if(a<0 || getvar("mp_timelimit")*60+2 != origtimelimit){
        	checktime = systemtime()-(systemtime()- checktime);
        	time_change();       
        }
      	selfmessage("------------------------------------");
      	return PLUGIN_HANDLED;
}


public admin_tm_load(HLCommand,HLData,HLUserName,UserIndex){
	
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)!=0){
		checktime = systemtime()-(systemtime()- checktime);
        	time_change();
		tm_line=0;
		set_vaultdata("TM_FILE",Data);
		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Einlesen: %s%s",TextFileDir,Data);
		strcpy(Text,Text,98);
        	selfmessage(Text);
        	read_file();
        }else{
        	snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Datei-Angabe fehlt!");
        	selfmessage(Text);
       	}
        return PLUGIN_HANDLED;
}

public admin_tm_write(HLCommand,HLData,HLUserName,UserIndex){
	
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new TimeCommand[MAX_DATA_LENGTH];
	new File[MAX_DATA_LENGTH];
	new i;
	
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)!=0){
		snprintf(File,MAX_DATA_LENGTH,"%s%s",TextFileDir,Data);
		for(i=0;i<=tm_line;i++){
			snprintf(TimeCommand,MAX_DATA_LENGTH,"%s %s",Time[i],Execute[i]);
			writefile(File,TimeCommand,-1);
		}
		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Daten in %s%s gespeichert.",TextFileDir,Data);
		strcpy(Text,Text,98);
        	selfmessage(Text);
        }else{
        	snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Datei-Angabe fehlt!");
        	selfmessage(Text);
       	}
        return PLUGIN_HANDLED;
}

/*Haupt-Zeit-Funktionen*/

public tm_welt(HLCommand,HLData,HLUserName,UserIndex){
        new Data [MAX_DATA_LENGTH];
        new a;
                                                     
        convert_string( HLData, Data, MAX_DATA_LENGTH );
        
        if(Data[0]=='G' && GameCommencing == 0){
                GameCommencing = 1;
                checktime =systemtime();
                tm_best_player(1);
                time_change();
        }else if(Data[8]=='R'){
                checktime = systemtime();
                tm_best_player(1);
                time_change();
        }else if(Data[6]=='S'){
                if (getvar("mp_timelimit")*60+2 != origtimelimit){
                        checktime = systemtime()-(systemtime()- checktime);
                        time_change();
                }else{
                	/*Zusatz-Kontrolle einer Zeitvernderung nach jeder Runde!*/
	                map_time();
	                a=time-strtonum(Time[tm_pointer]);
	                if(a<0){
	                	checktime = systemtime()-(systemtime()- checktime);
	                	time_change();
	                }else{
	                	iRound++;
	                	tm_best_player(0);
	                }
		}
        }
        return PLUGIN_CONTINUE;
}

public tm_warn(Timer,Repeat,HLUser,HLParam){
	new Text[MAX_TEXT_LENGTH];
        new a;
        new i;
        new iTime;
        new iTime2;
        new x;
        
        if (getvar("mp_timelimit")*60+2 != origtimelimit){
        	checktime = systemtime()-(systemtime()- checktime);
        	time_change();
        }else{
	       	tm_best_player(0);
	       	map_time();
	       	
	        iTime=strtonum(Time[tm_pointer]);
	        
	        if(time==iTime){
	        	/*Alles durchgehen, was zu dem Zeitpunkt ausgefhrt werden muss*/
	        	x=tm_pointer;
	        	for(i=x;i<=tm_line;i++){
	        		iTime=strtonum(Time[tm_pointer]);
	        		if(time==iTime){
		        		execute(Execute[tm_pointer]);
		        		tm_pointer++;
		        	}
	        	}
	        	iTime=strtonum(Time[tm_pointer]);
	        }
	        if(iTime !=0){
	        	a = time - iTime;
	        	/*wenn die Mapzeit < als die Zeitangabe aus der command.ini ist, andere Zeit-
	        	angabe mit Befehl suchen, die noch innerhalb der Mapzeit ausgefhrt werden
	        	kann */
	        	if(a<=0){
	        		for(i=0;i<=tm_line;i++){
	        			iTime2=strtonum(Time[i]);
	        			if(time>iTime2){
	        				a = time - iTime2;
	        				tm_pointer=i;
	        				break;
	        			}else{
	        				tm_pointer=i;
	        			}
	        		}
	        	}
	        	
	        	if(a>0){
	        		set_timer("tm_warn",a,0);
	        		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Naechster Befehl in %d Sekunden:'%s'",a,Execute[tm_pointer]);
		        }else{
		        	/*Ist a immer noch kleiner = 0 ist was schief gelaufen und wir brechen ab*/
		        	snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Konnte Zeit nicht ermitteln! Error! Plugin Abbruch!");
		        	plugin_exec("admin_tm_kill","");
		        }
		        if(debug==1){
	        		strcpy(Text,Text,98);
		        	selfmessage(Text);
		        }
	        }else{
	        	snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] %d mapzeitgebundene Befehle ausgefuehrt. Ende!",tm_pointer);
	        	selfmessage(Text);
	        }
	}
	return PLUGIN_CONTINUE;
}


/*Helper-Functions*/

execute(Data[]){
	new Text[MAX_TEXT_LENGTH];
	new Command[MAX_DATA_LENGTH];
	new Param[MAX_DATA_LENGTH];
	if(strncmp(Data,"admin_",6)==0){
		strsep(Data," ",Command,MAX_DATA_LENGTH,Param,MAX_DATA_LENGTH);
		plugin_exec(Command,Param);
	}else{
		exec(Data);
	}
	if(debug==1){
		snprintf(Text,MAX_TEXT_LENGTH,"[TIME_MANAGER] %s wurde ausgefuehrt!",Data);
		strcpy(Text,Text,98);
		selfmessage(Text);
	}
	return PLUGIN_CONTINUE;
}

map_time(){
	time = (origtimelimit-(systemtime()-checktime));
	return PLUGIN_CONTINUE;
}

read_file(){
	new TextFile[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new File[MAX_DATA_LENGTH];
	new iLine;
	new i;
	
        get_vaultdata("TM_FILE",File,MAX_TEXT_LENGTH);
        snprintf(TextFile,MAX_TEXT_LENGTH,"%s%s",TextFileDir,File);
                
	if(fileexists(TextFile)){
		/*iLine=filesize(TextFile);*/
		iLine=realfilesize(TextFile);
		if(iLine>MAX_LINE){
				iLine=MAX_LINE;
		}
		for(i=0;i<=iLine;i++){
			strinit(Data);
			readfile(TextFile,Data,i+1,MAX_DATA_LENGTH);
			if(strlen(Data)!=0 && strcmp(Data,"")!=0 && strncmp(Data,"/",1)!= 0){
        			strsep(Data," ",Time[tm_line],MAX_NUMBER_LENGTH,Execute[tm_line],MAX_DATA_LENGTH);
        			tm_line++;
        		}
        	}
        	tm_line-=1;
        	if(debug==1){
        		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] %i Befehle eingelesen",tm_line);
        		selfmessage(Text);
        	}
        }else{
        	snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Finde %s nicht!!!!",TextFile);
        	selfmessage(Text);
        }
	return PLUGIN_CONTINUE;
}

/*19.12.02: workaround von Blacky, um die korrekte Filegre zu ermitteln (bis AM 2.50.51)*/
realfilesize(fname[]){
	new sizeoffile;
	new sizeoffile2;
	new i;
	new string[MAX_DATA_LENGTH];

	sizeoffile=filesize(fname,1);
	sizeoffile2=sizeoffile;
	for(i=1; i<=sizeoffile2; i++) {
		readfile(fname,string,i,MAX_DATA_LENGTH);
		if(strlen(string)>98){
			sizeoffile-=1;
		}
		if(sizeoffile==i){
			break;
		}
	}
	return sizeoffile;
}

time_change(){
	if(debug==1){
		new Text[MAX_TEXT_LENGTH];
		snprintf(Text,MAX_TEXT_LENGTH,"[TIME-MANAGER] Aenderung gefunden! RESTART!");
        	selfmessage(Text);
        }
       	origtimelimit= getvar("mp_timelimit")*60+2;
        tm_pointer=0;
      	set_timer("tm_warn",1,0);
      	return PLUGIN_CONTINUE;
}

/*Fr Ausgabe-Variablen in der vault.ini zu erhalten*/

/*Team-Score, Bester Spieler und meiste Frags*/
public tm_showintheend(HLCommand,HLData,HLUserName,UserIndex){
	new Params[MAX_DATA_LENGTH];
	new Data1[MAX_DATA_LENGTH];                                
        new Data2[MAX_DATA_LENGTH];  
	new dummy[MAX_DATA_LENGTH];
	
	convert_string(HLData,Params,MAX_DATA_LENGTH);
	strbreak(Params,Data1,Data2,MAX_DATA_LENGTH);
	strsplit(Data2, "# " ,dummy,MAX_DATA_LENGTH,dummy,MAX_DATA_LENGTH,ScoreCT,MAX_NUMBER_LENGTH,dummy,MAX_DATA_LENGTH,ScoreT,MAX_NUMBER_LENGTH);
	
	tm_best_player(0);
	return PLUGIN_CONTINUE;
}
	
tm_best_player(refresh){
	new Player[MAX_NAME_LENGTH];
	new BestPlayer[MAX_NAME_LENGTH];
	new iFrags;
	new iMostFrags;
	new i;
	new maxplayers=maxplayercount();

	map_time();
	
	if(time>5 && refresh ==0){
		for(i=1;i<=maxplayers;i++){
			if(playerinfo(i,Player,MAX_NAME_LENGTH)){
				get_userFrags(Player,iFrags);
				if(iFrags>iMostFrags){
					iMostFrags=iFrags;
					strcpy(BestPlayer,Player,MAX_NAME_LENGTH);
				}
			}
		}
	}else{
		iRound		=0;
		iMostFrags	=0;
		ScoreCT[0]	=0;
		ScoreT[0]	=0;
		BestPlayer[0]	=0;
	}
	
	set_vaultini(iMostFrags,BestPlayer);
	
	return PLUGIN_CONTINUE;
}

set_vaultini(iMostFrags,BestPlayer[]){
	/*globale Variablen*/
	set_vaultnumdata("TM_MAPTIME",time);
	set_vaultnumdata("TM_ROUND",iRound);
	set_vaultdata("TM_SCORE_T",ScoreT);
	set_vaultdata("TM_SCORE_CT",ScoreCT);
	
	/*bergebene Variablen*/
	set_vaultnumdata("TM_MOST_FRAGS",iMostFrags);
	set_vaultdata("TM_BEST_PLAYER",BestPlayer);
	if(debug==1){
		selfmessage("[TIME-MANAGER] Habe vault.ini Eintraege angepasst!");
	}	
	return PLUGIN_CONTINUE;
}

public plugin_connect(HLUserName,HLIP, UserIndex){
	tm_best_player(0);
	return PLUGIN_CONTINUE;
}

/*Alles zum Timeleft*/
SpeakTimeleft() {
        new i;
	new maxplayers = maxplayercount();
	new SessionID;
	new Target[MAX_NAME_LENGTH];
	new WONID;
	new outputstring[MAX_DATA_LENGTH];
	new seconds;
	new minutes;
	new first; 
        new second; 
        new third; 
        new fourth;
        new Minutes[MAX_TEXT_LENGTH];
        new Seconds[MAX_TEXT_LENGTH];
        new Authid[MAX_AUTHID_LENGTH];
		
	new low[20][]={"","one ", "two ","three ","four ","five ","six ","seven ","eight ","nine ","ten ","eleven ","twelve ","thirteen ","fourteen ","fifteen ","sixteen ","seventeen ","eighteen ","nineteen "}; 
        new high[10][]={"", "", "twenty ","thirty ","fourty ","fifty ","sixty ","seventy ","eighty ","ninety "}; 
        
        minutes=time/60; 
        seconds=time%60; 
        
        if(minutes<=0 && seconds <=0){
        	 return PLUGIN_FAILURE;
       	}

        first=minutes/10; 
        second=minutes%10; 
        
        if(first==1){ 
            second=minutes; 
            first=0; 
        } 
        
        third=seconds/10; 
        fourth=seconds%10; 
        
        if(third==1){ 
            fourth=seconds; 
            third=0; 
        } 
               
        if(minutes>0){ 
            snprintf(Minutes, MAX_DATA_LENGTH, "%s%s", high[first], low[second]); 
        } 
        
        if(seconds>0){ 
            snprintf(Seconds, MAX_DATA_LENGTH, "%s%s ", high[third], low[fourth]); 
        } 
        
        snprintf(outputstring,MAX_DATA_LENGTH,"fvox/%s minutes %s seconds remaining",Minutes,Seconds ); 
        
	for(i=1; i<=maxplayers; i++) {
		strinit(Target);
		if(playerinfo(i,Target,MAX_NAME_LENGTH,SessionID,WONID,_,_,Authid)==1) {
			if(strcmp(Authid,"BOT")!=0){
				speakto(Target,outputstring);
			}
		}
	}
	return PLUGIN_HANDLED;
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);

	strstripquotes(Data);
	if (streq(Data, "timeleft")==1) {
		checktime = systemtime()-(systemtime()- checktime);
		map_time();
		if (systemtime() < iLastSpeak) {
			return PLUGIN_CONTINUE;
  		} else {
			SpeakTimeleft();
			iLastSpeak = systemtime();
			iLastSpeak += 60;
		}
	}
	return PLUGIN_CONTINUE;
}
	
	
public plugin_init(){
        plugin_registerinfo("LogD-Time-Manager","Executing commands within maptime",STRING_VERSION);
        plugin_registercmd("tm_welt", "tm_welt", ACCESS_CONSOLE);
        plugin_registercmd("tm_showintheend", "tm_showintheend", ACCESS_CONSOLE);
        plugin_registercmd("admin_tm_kill","admin_tm_kill",ACCESS_MAP,"admin_tm_kill : Loescht alles Tasks");
        plugin_registercmd("admin_tm_list", "admin_tm_list", ACCESS_MAP,"admin_tm_list <ab TaskNr>: Zeigt eine Liste aller Tasks ab TaskID + 10");
        plugin_registercmd("admin_tm_add","admin_tm_add",ACCESS_RCON,"admin_tm_add <Maptime> <Command>: Fuegt einen neuen Task hinzu");
        plugin_registercmd("admin_tm_del","admin_tm_del",ACCESS_RCON,"admin_tm_del <TaskID>: Loescht den Task mit der ID");
        plugin_registercmd("admin_tm_exec","admin_tm_exec",ACCESS_RCON,"admin_tm_exec <TaskID>: Fuehrt den Task direkt aus!");
        plugin_registercmd("admin_tm_load", "admin_tm_load", ACCESS_RCON,"admin_tm_load <filename>: laedt eine neue Taskliste und loescht die Alte");
        plugin_registercmd("admin_tm_write","admin_tm_write",ACCESS_RCON,"admin_tm_write <filename>: speichert die Taskliste in das angegeben File");
        plugin_registercmd("say","HandleSay",ACCESS_ALL);
	plugin_registerhelp("say",ACCESS_ALL,"say timeleft: Will speak the time left.");
        exec("logd_reg 61 admin_command tm_showintheend");
        exec("logd_reg 62 admin_command tm_welt");
        
        checktime =systemtime();
        origtimelimit = getvar("mp_timelimit")*60+2;
        get_vaultnumdata("TM_DEBUG",debug);
        tm_best_player(1);
        map_time();
        read_file();
        return PLUGIN_CONTINUE;
}